// weakPtr1.cpp
// Demo zu weak_ptr.
// --------------------------------------------------
#include <iostream>
#include <memory>
using namespace std;

void print( weak_ptr<int> wp)    // Call by value (Kopierkonstruktor)
{
   shared_ptr<int> sp = wp.lock();
   if( sp)                       // Falls Objekt noch existiert
      cout << "Adresse: " << sp << "   Wert: " << *sp << endl;
   else
      cout << "Objekt nicht mehr vorhanden!" << endl;
}

int main()
{
//   shared_ptr<int> sp(new int(7));
   shared_ptr<int> sp = make_shared<int>(7);
     weak_ptr<int> wp1  ,                // Leerer Zeiger
                 wp2(sp);              // Verweis auf *sp
   wp1 = sp;                 // ok, alle zeigen jetzt auf *sp.

   cout << "Referenzzaehler: " << wp2.use_count() << endl;  // 1
   print(wp2);
   sp.reset();               // Zerstrt *sp
   print(wp2);               // wp.lock() ist leer.

   try
   {   
      shared_ptr<int> sp(wp2);     // Exception bad_weak_ptr.
      cout << "Diese Anweisung wird nicht erreicht" << endl;
   }
   catch( bad_weak_ptr& e) { cerr << e.what() << endl; }
   catch(...) { cerr << "Unerwartete Exceptionn!" << endl; }

   return 0;
}

/*
// weakPtr1.cpp
// weak_ptr in einer doppelt veketteten Liste.
// --------------------------------------------------
#include <memory>
#include "person.h"
using namespace std;

class PersonList {
    struct Element { 
      Person person; 
      shared_ptr<Element> next;  weak_ptr<Element> prev;
      Element(const Person& p = Person()) : person(p) {} };
    shared_ptr<Element> first;
  public:
    void push_front(const Person& pers)
    { shared_ptr<Element> ePtr(new Element(pers));
      if(first){ ePtr->next = first; first->prev = ePtr; }
      first = ePtr;
    }
    void clear() { first.reset(); }
};

int main()
{
   PersonList myList;
   cout << "Liste wird gefuellt.\n"
           "(Temporaere Objekte werden kopiert.)" << endl;
   myList.push_front( Person("Adam"));
   myList.push_front( Person("Eva"));

   cout << "\nListe wird geloescht:" << endl;
   myList.clear();
   return 0;
}
*/
/* Ausgabe:


*/
