// polynom_t.cpp:     Klasse Polynom testen
// ----------------------------------------------------
#include "matrix.h"
#include <iostream>
#include <iomanip>
using namespace std;

template<class T>
void display( const Matrix<T>& m);

int main()
{ 
    double elem[9] = { 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0 };
    Matrix<double> m(elem,2,3);    // Matrix mit den ersten 6 Elementen
    display(m);

    Matrix<double> m2(m);
    m2(1,2) = 7.0;
    cout << "2. Matrix: " << endl;
    display(m2);

    Matrix<double> sm = m.subMatrix(0,1,1,1);
    cout << "Sub-Matrix: " << endl;
    display(sm);

    Matrix<double> mi = m.minor(0,1);
    cout << "Minor: " << endl;
    display(mi);

    Matrix<double> tm = m.transponierte();
    cout << "Transponierte: " << endl;
    display(tm);

    Matrix<double> mm(elem,3,3), null(3,3); 
    Matrix<double>  ut = mm.upperTriangle(null);
    cout << "upperTriangle: " << endl;
    display(ut);

    return 0;
}

template<class T>
void display( const Matrix<T>& m)
{
    for( int r = 0; r < m.getRows(); ++r)
    {
        for( int c = 0; c < m.getCols(); ++c)
            cout << setw(6) << m[r][c]; 
        cout << endl;
    }
}
