// ----------------------------------------------------- 
//   SinKurve.cpp
//   Ausgabe der sinus-Kurve
// ------------------------------------------------------------
//   Statt der ANSI-Bildschirmsteuerzeichen werden hier
//   die Funktionen der Windows-API verwendet.
// ------------------------------------------------------------

#include <iostream>
#include <cmath>                      // Prototypen von sin()
using namespace std;

#include "..\..\console\console.h"      // Win32 Konsolenfunktionen

#define  CLS          cls()              // Bildschirm loeschen
#define  LOCATE(z,s)  setCursor(z-1,s-1) // Cursor in Zeile z, 
                                         // Spalte s positionieren.
#define PI        3.1415926536
#define START     0.0              // Untergrenze
#define ENDE     (2.0 * PI)        // Obergrenze
#define PKT       64               // Anzahl Punkte der Kurve
#define SCHRITT  ((ENDE-START)/PKT)
#define xA        14               // Zeile  fr x-Achse
#define yA        10               // Spalte fr y-Achse

int main()
{
    int  zeile, spalte;

    CLS;
    LOCATE(2,25);
    cout << "-------  Die Sinus-Funktion  -------";


    //    ---  Koordinaten-Kreuz zeichnen: ---  

    LOCATE(xA,1);                               // x-Achse
    for( spalte = 1 ; spalte < 78  ; ++spalte)
    {
        cout << ((spalte - yA) % 8  ?  '\304' : '\305');
    }
    cout << '\020';                             // Spitze
    LOCATE(xA-1, yA+64);  cout << "2PI  x";

    for( zeile = 5 ; zeile < 24 ; ++zeile)      // y-Achse
    {
       LOCATE(zeile, yA);  cout << '\305';
    }
    LOCATE( 4, yA);  cout << "\036 sin(x)";     // Spitze

    LOCATE( xA-8, yA+1);  cout << " 1";
    LOCATE( xA+8, yA+1);  cout << " -1";


    //     ---  sinus-Funktion ausgeben:  --- 

    int anfsp = yA,
        endsp = anfsp + PKT;

    for( spalte = anfsp ;  spalte <= endsp  ;  ++spalte)
    {
       double x = (spalte-yA) * SCHRITT;
       zeile = (int)(xA - 8 * sin(x) + 0.5);
       LOCATE( zeile, spalte);  cout << '*';
    }

    LOCATE(25,1);              // Cursor in letzte Zeile 

    return 0;
}
