// ----------------------------------------------------
// swap.cpp
// Definition und Aufruf der Funktion swap().
// 1. Version mit Zeigern als Parameter,
// 2. Version mit Referenzen als Parameter.
// ----------------------------------------------------

#include <iostream>
using namespace std;

void swap( float*, float*);   // Prototypen von swap()
void swap( float&, float&);
 
int main()
{
  float x = 11.1F;
  float y = 22.2F;

  cout << "x und y vor dem Tauschen:  "
       << x << "   " << y << endl;
  
  swap( &x, &y);       // Version mit Zeigern aufrufen.

  cout << "x und y nach dem 1. Tauschen: "
       << x << "   " << y << endl;
 
  swap( x, y);         // Version mit Referenzen aufrufen.

  cout << "x und y nach dem 2. Tauschen: "
       << x << "   " << y << endl;
 
  return 0;
} 

void swap(float *p1, float *p2)    // Version mit Zeigern
{
  float temp;          // Hilfsvariable 

  temp = *p1;          // Bei obigem Aufruf zeigen
  *p1  = *p2;          // p1 auf x und p2 auf y.
  *p2  = temp;
}

/*
// Eine Version von swap(), die logisch falsch ist.
// Wo liegt der Fehler?

void swap(float *p1, float *p2)
{
  float *temp;         // Hilfsvariable 

  temp = p1;
  p1   = p2;
  p2   = temp;
}
*/


void swap(float& a, float& b)    // Version mit Referenzen
{
  float temp;          // Hilfsvariable 

  temp = a;            // Bei obigem Aufruf ist
  a    = b;            // a gleich x und b gleich y
  b    = temp;
}
