// DayTime.h
// Die Klasse DayTime mit den Operatoren < und ++ .
// Die Klasse stellt die Uhrzeit mit Stunden, Minuten 
// und Sekunden dar.
// ---------------------------------------------------

#ifndef _DAYTIME_
#define _DAYTIME_

#include <iostream>
#include <iomanip>
using namespace std;
 
class DayTime
{
  private:
    short hour, minute, second;
    bool overflow;

  public:
    DayTime( int h = 0, int m = 0, int s = 0)
    { 
      overflow = false;
      if( !setTime( h, m, s)) 
        hour = minute = second = 0;
    }
    bool setTime(int hour, int minute, int second = 0)
    {
      if(    hour   >= 0  &&  hour < 24 
          && minute >= 0  &&  minute < 60
          && second >= 0  &&  second < 60 ) 
      {
        this->hour   = (short)hour; 
        this->minute = (short)minute; 
        this->second = (short)second; 
        return true;
      }
      else
        return false;
    }
    int getHour()   const { return hour;   }
    int getMinute() const { return minute; };
    int getSecond() const { return second; };

    int asSeconds() const    // Tageszeit als Sekunden
    {
      return (60*60*hour + 60*minute + second);
    } 
 
    bool operator<( const DayTime& t) const
    {                              // *this mit t vergl.
      return  asSeconds() < t.asSeconds();
    } 
    
    DayTime& operator++()          // Sekunden erhhen.
    {
      ++second;
      if( second >= 60)       // und berlauf behandeln. 
          second = 0,  ++minute;
      if( minute >= 60)
          minute = 0,  ++hour;
      if( hour >= 24)
          hour = 0,  overflow = true;

      return  *this;
    } 

    void print() const
    {
      cout << setfill('0')
           << setw(2) << hour    << ':'
           << setw(2) << minute  << ':'
           << setw(2) << second  << " Uhr" << endl;
      cout << setfill(' ');
    }
};

#endif   // _DAYTIME_
