// ------------------------------------------------------
// kombi.h : Definition der Klasse Transporter und
//           der mehrfach abgeleiteten Klasse Kombi
// ------------------------------------------------------
#ifndef _KOMBI_H
#define _KOMBI_H

#include "kfz.h" 

class Transporter : public virtual Kfz
{
  private:
    double last;

  public:
    Transporter(long n=0L, const string& hst="", double l=0.0)
    : Kfz(n,hst)  
    {
        if(l > 750)  
            last = 750;
        else
            last = l ; 
    }
     
    void setLast(double l)
    {
        if(l > 750)  
            last= 750;
        else
            last = l;
    }
    double getLast() const { return last; }

    void display() const
    {
       cout << "Last:         " 
            << last  << " kg" << endl;
    }
};

class Kombi : public Pkw, public Transporter
{
   private:
      int anz;          // Anzahl Sitzpltze
   public:
      Kombi(const string& tp="ohne Typ", bool sb=false, long n=0L, 
            const string& hst="ohne Herst", double l=0.0, int z = 1) 
      : Pkw(tp, sb), Kfz(n, hst), Transporter(n,hst,l), anz(z)
      { }

      void display() const
      {
         Pkw::display();
         Transporter::display();
      
         cout << "Sitzplaetze:  " << anz << endl;
      }
};
#endif
