// calc_neu.cpp: Neue Version der Funktion calc(),
//               die Exceptions vom Typ MathError
//               auslst.
// ----------------------------------------------------
#pragma warning( disable : 4290 )  // VC untersttzt keine Ausnahmespezifikation 

#include <string>
#include <iostream>
using namespace std;

class MathError
{
   private:
     string message;
   public:
     MathError( const string& s) : message(s) {}
     const string& getMessage()const {return message;}
};
 
 double calc( int a, int b ) throw(MathError);
 
 int main()
 {
    int x, y;  bool flag = false;
 
    do
    {
      try                                 // try-Block
      {
        cout << "Zwei positive ganze Zahlen eingeben: ";
        if( !(cin >> x >> y) )
			break;                        // Keine Zahlen! 
        cout << x <<"/"<< y <<" = "<< calc( x, y) << '\n';
        flag = true;        // Dann Schleife verlassen.
      }
      catch( MathError& err)              // catch-Block
       {
         cerr << err.getMessage() << endl;
       }
     }while(!flag); // und weiter im Programm ...
     return 0; 
 }
 
 double calc( int a, int b ) throw (MathError)
 {
    if ( b < 0 )
       throw MathError("Nenner ist negativ!");
    if( b == 0 )
       throw MathError("Division durch 0!");
    return ((double)a/b);
 }
