// --------------------------------------------------- 
// raster_t.cpp:  Legt eine Bitmap mit 24*80 Pixeln an
//                zum Testen des Bresenham-Algorithmus 
//                im Textmodus.
// --------------------------------------------------- 

#include <iostream>
using namespace std;

#include "bitmap.h"

int main()
{
   Bitmap<60,24> bm;        // NX == 60, NY == 24

   try
   {
      bm.moveTo(0, 0);    bm.lineTo(59,23);
      bm.moveTo(0,23);    bm.lineTo(59, 0);
   }
   catch(invalid_argument& e)
   {
       cerr << e.what(); 
       exit(1);
   }

   int size =  bm.size(),
       xSize = bm.xSize();

   for( int i = 0; i < size; i++)
   {
       cout << (bm[i] ? '*' : ' ');
       if( (i+1) % xSize == 0 )
           cout << endl;
   }

   return 0;
}
