// ------------------------------------------------------------
// quadmat.h:  Definition des Klassen-Templates QuadMatrix
//             zur Darstellung quadratischer Matrizen.
// ------------------------------------------------------------
#pragma warning( disable : 4290 )  // VC untersttzt keine Ausnahmespezifikation 
#include <iostream>
#include <stdexcept>
using namespace std; 
 
template <class T = int, int anz = 5>
class QuadMatrix
{
   private:
     T mat[anz][anz];
   
   public:
     int dim() const{ return anz; }

     T*  operator[](int line) throw(out_of_range)
     {  
       if( line < 0 || line >= anz)
         throw out_of_range("Matrix: Index out of range");
       else
         return mat[line];
     }

     const T*  operator[](int line) const throw(out_of_range)
     {  
        if( line < 0 || line >= anz)
           throw out_of_range("Matrix: Index out of range");
        else
           return mat[line];
     }
     //    const T* operator[](int line) const throw(out_of_range);

     T&  operator()(int line, int col) throw(out_of_range);
     const T&  operator()(int line, int col) const throw(out_of_range); 
 
//     friend QuadMatrix& operator+(const QuadMatrix&, 
//                                  const QuadMatrix&);
     // usw.
};

template <class T, int anz>
T& QuadMatrix<T, anz>::operator()(int line, int col) throw(out_of_range)     
{
    if( line < 0 || line >= anz || col < 0 || col >= anz)
       throw out_of_range("Matrix: Index out of range");
    else
      return mat[line][col];
}

template <class T, int anz>
const T& QuadMatrix<T, anz>::operator()(int line, int col) const throw(out_of_range)     
{
    if( line < 0 || line >= anz || col < 0 || col >= anz)
       throw out_of_range("Matrix: Index out of range");
    else
      return mat[line][col];
}




