// unorderedMap.cpp: Zum Testen von ungeordneten Maps
// -----------------------------------------------------
#include <unordered_map>
#include <string>
#include <iostream>
using namespace std;

typedef unordered_map<string, unsigned long> UNORDERED_MAP;
typedef UNORDERED_MAP::iterator ITERATOR;

int main()
{
    UNORDERED_MAP  m;            // Ungeordnete Map anlegen.
    ITERATOR pos;                // Iterator.
                                 // Einfgen:   
    m.insert(pair<string, unsigned long>("Mayer", 1234567)); 
                                 // Auch mglich:
    m["Mahler"] = 7654321UL;
    m["Mandel"] = 1357642UL;

    for(pos = m.begin(); pos!= m.end(); pos++)
        cout << "Bucketnr. " << m.bucket(pos->first) << ":  "
             << pos->first << "  " << pos->second << endl; 
 
    cout << "\nAnzahl Buckets:  "      << m.bucket_count() 
         << "\nAnzahl Objekte:  "      << m.size()  
         << "\nBelegungsfaktor: "      << m.load_factor()
         << "\nMax. Belegungsfaktor: " << m.max_load_factor();

    return 0;
}
