// myList_t.cpp
// Die doppelt verkette Liste MyList<T> testen. 
// --------------------------------------------------
#include <iostream>
#include <algorithm>
#include <cctype>
#include "person.h"
#include "myList.h"
using namespace std;

void toUpper( Person& person)        // Name in Grobuchstaben
{                                    // Fr for_each()
   string n(person.getName());
   for( unsigned i = 0; i < n.length(); ++i)
       n[i] = toupper(n[i]);
   person.setName(n);
}

int main()
{
   MyList<Person> myList;
   cout << "Liste wird gefuellt.\n"
           "(Temporaere Objekte werden kopiert.)" << endl;
   myList.push_front( Person("Max"));
   myList.push_front( Person("Vivi"));
   myList.push_back( Person("Eva"));

   cout << "\nDas erste Element: " 
        << myList.front().getName() << endl;       // Vivi
   cout << "Das letzte Element: "
        << myList.back().getName() << endl;        // Eva

   MyList<Person> yourList( myList);      // Kopierkonstruktor
   cout << "Kopie der Liste: " << endl;
   cout << yourList << endl;              // Vivi   Max    Eva

   yourList.append( myList);
   yourList.pop_front();
   yourList.pop_back();
   yourList.front().setName("Xaver");

   cout << "2. Liste nach einigen Operationen: \n"
        << yourList << endl;          // Xaver  Eva   Vivi  Max 

   cout << "Und eine Zuweisung." << endl;
   myList = yourList;                       // Zuweisung

   cout << "Operationen mit Iteratoren:" << endl;
   // Ausgabe mit Iteraoren:
   MyList<Person>::Iterator iter = myList.begin();
   for( ; iter != myList.end(); ++iter)
       cout << '\t' << iter->getName();
   cout << endl;

   cout << " ... in umgekehrter Reihenfolge:" << endl;
   if( !myList.empty())
   {
     iter = myList.end();
     do {
         cout << '\t' << (--iter)->getName(); }
     while( iter != myList.begin() );
     cout << endl;                   //  Max   Vivi   Eva   Xaver
   }

   cout << " ... in Grossbuchstaben:" << endl;
   for_each( myList.begin(), myList.end(), toUpper);
   cout << myList << endl;           //  XAVER   EVA   VIVI   MAX

   cout << "Weiter mit der <Return>-Taste ... ";
   cin.get();
   cout << "\n1. Liste wird geloescht:" << endl;
//   while( !myList.empty() )       // so auch mglich.
//       myList.pop_front();
   myList.clear();

   cout << "Ende von main()." << endl;
   return 0;
}
