// Lamdas.cpp
// Beispiele fr Lambda-Funktionen
// ---------------------------------------------------------------
#include <algorithm>
#include <thread>
#include <iostream>
#include <iomanip>
using namespace std;

int main()
{ 
    auto lambda1 = [] { cout << "Eine Lamda-Funktion" << endl; };
    lambda1(); 

    [](){ cout << "Direkter Aufruf" << endl; } ();

    int n = 1;
    auto lambda2 = [=] (int a) mutable
    { n+=a; cout << "In der Lambda-Funktion:   n = " << n << endl; };
    lambda2(7);
    cout << "Nach der Lambda-Funktion: n = " << n << endl;      // n unverndert

    int arr[5] = { 1,2,3,4,5};
    for_each(arr, arr+5, [](int n) { cout.width(4); cout << n*n; } );
    cout << endl;
 /*
    // Array mit 20 Fibonacci-Zahlen fllen.
    long fibarr[20] = { 0, 1 };        // initialisieren
    long f0 = 0, f1 = 1;               // Die beiden Vorgnger.
    // Algorithmus generate:
    generate( fibarr + 2, fibarr+20, 
              [&f0, &f1] () ->long     // oder nur  [&f0, &f1]  
              {
                long f = f0 + f1;   f0 = f1;   f1 = f;
                return f;
              });
    for (auto& f : fibarr) { cout.width(8);  cout << f; }  // Anzeigen.
    cout << endl;
*/
    // In einem Thread 10 Sterne ausgeben:
    thread thr( [] {
           for (int n = 10; n > 0; --n) { cout << " *"; }cout << endl; });
    thr.join();
/*
    auto twice = [](auto a) { return a+a; };
//    auto twice = [](int a) { return a + a; };
//    auto twices = [](string a) { return a + a; };
    cout << twice(7) << endl;              // 14
    cout << twice("go") << endl;           // gogo
*/
    return 0;
}

/*
// generate.cpp: Funktionsobjekte und Lamda-Funktionen.
// ---------------------------------------------------------------
#include <iostream>
#include <array>            // Definition des array-Templates        
#include <algorithm>        // Definition der Algorithmen-Templates
using namespace std;

class Fibonacci            // Die ersten beiden Fibonacci-Zahlen 
{  long f0, f1;            // sind 0 und 1. Jede weitere ist die 
 public:                   // Summe ihre beiden Vorgnger.
    Fibonacci() : f0(0), f1(1) {}
    long operator() ()
    {
       long f = f0 + f1;   f0 = f1;   f1 = f;
       return f;
    }
};

void print( long elm) {  cout.width(8);  cout << elm; }

int main()
{
    array<long,20> arr1 = {0,1};         // Array mit der Lnge 20

    // Array mit 20 Fibonacci-Zahlen fllen.
    // 1. Funktionsobjekt verwenden:
    generate( arr1.begin()+2, arr1.end(), Fibonacci() );

    cout << "Die ersten 20 Fibonacci-Zahlen: " << endl;
    for_each( arr1.begin(), arr1.end(), print);
    cout << endl;

    // 2. lambda-Funktionen verwenden:
    std::array<long,20> arr2 = {0,1};         // Array mit der Lnge 20

    generate( arr2.begin()+2, arr2.end(), []() ->long
    {
       static long f0(0), f1(1);
       long f = f0 + f1;   f0 = f1;   f1 = f;
       return f;
    } );

    cout << "Die ersten 20 Fibonacci-Zahlen: " << endl;
    for_each( arr2.begin(), arr2.end(),
              [](long elm){ cout.width(8);  cout << elm; } );
    cout << endl;

    // Variante mit lambda-Funktionen:
    arr2.fill(0); arr2[1] = 1;       // Neu initialisieren
    long f0 = 0, f1 = 1;             // Die beiden Vorgnger.
    
    generate( arr2.begin()+2, arr2.end(), [&f0,&f1]() ->long
    {
       long f = f0 + f1;   f0 = f1;   f1 = f;
       return f;
    } );

    cout << "Die ersten 20 Fibonacci-Zahlen: " << endl;
    for_each( arr2.begin(), arr2.end(),
              [](long elm){ cout.width(8);  cout << elm; } );
    cout << endl;

    return 0;
}
*/
