// ------------------------------------------------------- 
// myMakros.h 
// Header-Datei mit den Makros 
// ABS, MIN, MAX, CLS, LOCATE, FARBE, NORMAL, INVERS
// und symbolische Konstane fr Farben.
// -------------------------------------------------------- 
// Version fr Win32
// ==> Verwendet die Quelldateien console.h und console.cpp
// -------------------------------------------------------- 

#ifndef _MYMAKROS_
#define _MYMAKROS_

#include "..\..\console\console.h"       // Win32 Konsolenfunktionen

// -------------------------------------------------------------
// Makro ABS
// Aufruf:  ABS( wert) 
// Liefert den Absolutwert von wert
 
#define ABS(a) ( (a) >= 0 ? (a) : -(a))

// -------------------------------------------------------------
// Makro MIN
// Aufruf:  MIN(x,y) 
// Liefert das Minimum von x und y

#define MIN(a,b) ( (a) <= (b) ? (a) : (b))

// -------------------------------------------------------------
// Makro MAX
// Aufruf:  MAX(x,y) 
// Liefert das Maximum von x und y

#define MAX(a,b) ( (a) >= (b) ? (a) : (b))


//-----------------------------------------------------------
// Makros zur Steurung des Bildschirms
// -------------------------------------------------------------
// Makro CLS
// Aufruf:  CLS; 
// Lscht den Bildschirm 

#define  CLS          cls()              // Bildschirm loeschen

// -------------------------------------------------------------
// Makro LOCATE
// Aufruf:  LOCATE(zeile, spalte); 
// Setzt den Cursor auf die angegebene Position (zeile,spalte).
// (1,1) ist linke obere Ecke.

#define  LOCATE(z,s)  setCursor(z-1,s-1) // Cursor in Zeile z,
                                         // Spalte s positionieren.

// -------------------------------------------------------------
// Makro FARBE
// Aufruf:  FARBE(vordergrund, hintergrund); 
// Setzt die Vordergrundfarbe v und Hintergrundfarbe h 
// fr nachfolgende Ausgaben.

#define FARBE( v, h)  setColor( v | (h<<4) | FOREGROUND_INTENSITY)

// Farbwerte fr das Makro FARBE
// Beispielaufruf: FARBE( WEISS,BLAU);

#define SCHWARZ  0
#define BLAU     1
#define GRUEN    2
#define ROT      4
#define CYAN     3
#define MAGENTA  5
#define GELB     6
#define WEISS    7


// -------------------------------------------------------------
// Makro NORMAL
// Aufruf:  NORMAL; 
// Setzt die Bildschirmattribute auf die Standardwerte zurck.

#define NORMAL   setColor( FOREGROUND_WHITE)


// -------------------------------------------------------------
// Makro INVERS
// Aufruf:  INVERS; 
// Die nachfolgende Ausgabe wird invers dargestellt.

#define INVERS   setColor( BACKGROUND_WHITE)

#endif   //  _MYMAKROS_
