// StrToL.cpp
// Die Funktion strToLong() konvertiert einen String,
// der eine ganze Zahl enthlt, in eine binre Zahl 
// vom Typ long.
// Die Ziffernfolge, der Zwischenraumzeichen und ein 
// Vorzeichen vorausgehen knnen, wird dezimal interpretiert.
// Die Konvertierung endet am Stringende bzw. beim 1. Zeichen,
// das nicht verarbeitet werden kann. 
//
// Argument:    Ein String.
// Return-Wert: Die binre Zahl vom Typ long.
// --------------------------------------------------

#include <string>
#include <cctype>
using namespace std;

long strToLong( string str)
{
   register unsigned int i = 0;      // Index
   long vz = 1, zahl = 0;            // Vorzeichen und Zahl
   
   // Fhrende Zwischenraumzeichen berlesen
   for(i=0; i < str.size() && isspace(str[i]); ++i)
       ;

   // Ist ein Vorzeichen vorhanden?
   if( i < str.size())
   {
       if( str[i] == '+' ) { vz = 1;  ++i; }
       if( str[i] == '-' ) { vz = -1; ++i; }
   }

   // Ziffernfolge -> Zahl umwandeln
   for( ; i < str.size() && isdigit(str[i]); ++i)
      zahl = zahl * 10 + (str[i] - '0');
   
   return vz * zahl;
}
