// ---------------------------------------------------
// datum.cpp 
// Implementierung der Methoden der Klasse Datum,
// die nicht schon inline definiert sind.
// ---------------------------------------------------
#define _CRT_SECURE_NO_WARNINGS    // Fr localtime()

#include "datum.h"

#include <iostream>
#include <sstream>
#include <iomanip>
#include <string>
#include <ctime>
using namespace std;

// ---------------------------------------------------
void Datum::setDatum()  // Aktuelles Datum holen und 
{                       // den Datenelementen zuweisen.
   struct tm *zeit;         // Zeiger auf Struktur tm.
   time_t sec;              // Fr die Sekunden. 

   time(&sec);              // Aktuelle Zeit holen.
   zeit = localtime(&sec);  // Eine Struktur vom Typ tm
                            // initialisieren und Zeiger
                            // darauf zurckgeben.
   tag   = (short) zeit->tm_mday;
   monat = (short) zeit->tm_mon + 1;
   jahr  = (short) zeit->tm_year + 1900;
}

// ---------------------------------------------------
bool Datum::setDatum( int tg, int mn, int jr)  
{
   if( tg < 1 ||  tg > 31 ) return false;
   if( mn < 1 ||  mn > 12 ) return false;

   switch(mn)       // Monate mit weniger als 31 Tagen
   {
    case 2:  if( isLeapYear(jr))
             {
               if( tg > 29)
                 return false;
             }
             else if( tg > 28)
               return false;
             break;
    case 4:
    case 6:
    case 9:
    case 11:
             if( tg > 30)  return false;
   }
   tag   = (short) tg;
   monat = (short) mn;
   jahr  = (short) jr;
   return true;
}

// ---------------------------------------------------
void Datum::print() const              // Datum anzeigen
{
    cout << asString() << endl;
}

// ---------------------------------------------------
const string& Datum::asString() const  // Datum als String
{                                      // zurckgeben.
   static string datumString;
   stringstream iostream;         // Zur Konvertierung Zahl -> String
   iostream << setfill('0')       // und Formatierung.
            << setw(2) << tag   << '.' 
            << setw(2) << monat << '.' << jahr;

   iostream >> datumString;
   return datumString;
}
