// ------------------------------------------------------
// str_cmp.cpp
// Zeigerversion str_cmp() der Standardfunktion strcmp()
// definieren und testen.
// ------------------------------------------------------

#include <iostream>
using namespace std;

#define MAXLEN 100    // Maximale Lnge der C-Strings

// Prototyp:
int str_cmp( const char* str1, const char* str2);

int main()            // str_cmp() testen
{
    char text1[MAXLEN], text2[MAXLEN]; 
    cout << "Test der Funktion str_cmp()" << endl;

    while( true)
    {
        cout << "Zwei Zeilen Text eingeben!\n"
                "Ende mit zwei leeren Zeilen.\n" << endl;
        cout << "1. Zeile: ";
        cin.sync();  cin.clear(); cin.get(text1,MAXLEN);
        cout << "2. Zeile: ";
        cin.sync();  cin.clear(); cin.get(text2,MAXLEN);

        if( text1[0] == '\0' && text2[0] == '\0')
            break;               // Beide Zeilen leer.

        int cmp = str_cmp( text1, text2);
        if( cmp < 0)
            cout << "Der 1. String ist kleiner!\n";
        else if( cmp == 0)
            cout << "Die beiden Strings sind gleich!\n";
        else
            cout << "Der 1. String ist groesser!\n";
        cout << endl;
    }
    return 0;
}

// ------------------------------------------------------
// Index-Version der Standardfunktion strcmp().
// strcmp() vergleicht zwei C-Strings lexikographisch.
// Der Return-Wert ist < 0, falls str1 < str2 
//                     = 0, falls str1 == str2 
//                     > 0, falls str1 > str2 .
// ------------------------------------------------------
/*
int strcmp( const char str1[], const char str2[])
{
   int i;
   for( i=0; str1[i] == str2[i] && str1[i] != '\0'; ++i)
      ;

   return (str1[i] - str2[i]);
}
*/

// ------------------------------------------------------
// Funktion str_cmp()
// Zeiger-Version der Standardfunktion strcmp().
// ------------------------------------------------------
int str_cmp( const char* str1, const char* str2)
{
   for( ; *str1 == *str2 && *str1 != '\0'; ++str1, ++str2)
      ;

   return (*str1 - *str2);
}
