// fcopy.cpp
// Kopiert Dateien
// Aufruf: fcopy  [ quelldatei  [ zieldatei ] ]
// ----------------------------------------------------
#define _CRT_SECURE_NO_WARNINGS   // Fr VS C++ und strcpy()

#include <iostream>
#include <fstream>
using namespace std;

char usage[] = "Aufruf: fcopy [quelldatei [zieldatei]]";

inline void openerror( const char *datei)
{
  cerr << "Fehler beim Oeffnen von " << datei << endl;
  exit(1);
}

bool copy( istream& is, ostream& os),   // Prototyp,
     ok = true;                         // ok-Flag.

int main(int argc, char *argv[])
{
  char quelle[256] = "", ziel[256] = "";

  switch( argc ) 
  {
   case 1:              // keine Datei angegeben
                        // ==> Dateinamen einlesen.
     cout << "Die Quelldatei wird auf die Zieldatei kopiert!\n"
          << "Quelldatei: ";
     cin.getline( quelle, 256);
     if( strlen(quelle) == 0)
     {
       cerr << "Keine Quelldatei angegeben!" << endl;
       return 1;
     }
     cin.sync();                     // nur neue Eingabe
     cout << "Zieldatei: ";
     cin.getline( ziel, 256);
     break;

   case 2:              // eine Datei angegeben.
     strcpy( quelle, argv[1]);
     break;

   case 3:              // Quell- und Zieldatei angegeben.
     strcpy( quelle, argv[1]);
     strcpy( ziel, argv[2]);
     break;
       
   default:             // Falscher Aufruf des Programms.    
     cerr << usage << endl;
     return 2;                // oder: exit(2);
  }

  if( strlen(ziel) == 0)      // Nur Quelldatei?
  {                           // ja ==> Auf cout ausgeben.
    ifstream infile(quelle); 
    if( !infile )
        openerror( quelle);
     
    ok = copy( infile, cout);
    // Datei wird vom ifstream-Destruktor geschlossen. 
  }
  else                        // Quelldatei binr auf
  {                           // Zieldatei kopieren.
    ifstream infile( quelle, ios::in | ios::binary); 
    if( !infile )
        openerror( quelle);
    else
    {
      ofstream outfile( ziel, ios::out | ios::binary); 
      if( !outfile)
         openerror( ziel);

      ok = copy( infile, outfile);
      if( ok)
        cerr << "Datei " << quelle 
             << " nach Datei " << ziel << " kopiert!" << endl;
    }
  }

  if(!ok)
  {
    cerr << "Fehler beim Kopieren!" << endl;
    return 3;
  }

  return 0; 
}

bool copy( istream& is, ostream& os)  // is nach os 
{                                     // kopieren.
  const int BufSize = 1024; 
  char buf[BufSize];
  do
  {
     is.read( buf, BufSize);
     if( is.gcount() > 0)
       os.write(buf, is.gcount());
  }
  while( !is.eof() && !is.fail() && !os.fail() );

  if( !is.eof() ) return false;
  else            return true;
}
