// mitarb.cpp: Die Methoden der Klassen Mitarbeiter,
//             Arbeiter und Angestellter.
// -------------------------------------------------
#include "mitarb.h"

Mitarbeiter& Mitarbeiter::operator=(const Mitarbeiter & m)
{
   if( this != &m )         // Keine Selbstzuweisung
    name = m.name;
 
   return *this;
}

void Mitarbeiter::display() const
{
    cout << "\n----------------------------"
         << "\nName:           " << name;
}

/*
// Redefinition, virtuell mit Referenz auf abgeleitete
// Klasse als Ergebnistyp. Wird noch nicht von allen 
// Compilern untersttzt  .
Angestellter& Angestellter::operator=(const Mitarbeiter& m)
{
   if( this != &m )         // Keine Selbstzuweisung
   {
     Mitarbeiter::operator=( m );
     gehalt = 0.0;
   }
 
   return *this;
}

*/

// Redefinition, virtuell  
Mitarbeiter& Angestellter::operator=(const Mitarbeiter& m)
{
   if( this != &m )         // Keine Selbstzuweisung
   {
     Mitarbeiter::operator=( m );
     gehalt = 0.0;
   }
 
   return *this;
}
 
// Standard-Zuweisung, nicht virtuell  
Angestellter& Angestellter::operator=(const Angestellter& a)
{
  if( this != &a )
  {
      Mitarbeiter::operator=( a );
      gehalt = a.gehalt;
  }
  return *this;
}

void Angestellter::display() const
{
   Mitarbeiter::display();
   cout << "\nGehalt:         " 
        << fixed << setprecision(2) << gehalt << endl;
}

/*
// Redefinition, virtuell mit Referenz auf abgeleitete
// Klasse als Ergebnistyp.
// Wird noch nicht von allen Compilern untersttzt.
Arbeiter& Arbeiter::operator=(const Mitarbeiter& m)
{
   if( this != &m )         // Keine Selbstzuweisung
   {
     Mitarbeiter::operator=( m );
     lohn = 0.0;
     std  = 0;
   }
 
   return *this;
}

*/

// Redefinition, virtuell  
Mitarbeiter& Arbeiter::operator=(const Mitarbeiter& m)
{
   if( this != &m )         // Keine Selbstzuweisung
   {
     Mitarbeiter::operator=( m );
     lohn = 0.0;
     std  = 0;
   }
 
   return *this;
}

// Standard-Zuweisung, nicht virtuell  
Arbeiter& Arbeiter::operator=(const Arbeiter& a)
{
  if( this != &a )
  {
      Mitarbeiter::operator=( a );
      lohn = a.lohn;
      std  = a.std;
  }
  return *this;
}

void Arbeiter::display() const
{  
   Mitarbeiter::display();
   cout << fixed << setprecision(2) 
        << "\nStundenlohn:    " << lohn
        << "\nAnzahlStunden:  " << std << endl;
}
