// ------------------------------------------------------
// fraction.h
// Eine numerische Klasse zur Reprsentierung von Brchen
// ------------------------------------------------------
#ifndef _FRACTION_
#define _FRACTION_
#pragma warning( disable : 4290 )  // VC untersttzt keine Ausnahmespezifikation 

#include <iostream>
#include <cstdlib>
using namespace std;

class Fraction
{
  private:
   long zaehler, nenner;

  public:

   class DivisionByZero
   {
         // Keine Datenelemente
   };
      
   Fraction(long z = 0, long n = 1) throw(DivisionByZero);

   Fraction operator-() const
   {
      return Fraction(-zaehler, nenner);
   }

   Fraction& operator+=(const Fraction& a)
   {
      zaehler = a.zaehler * nenner + zaehler * a.nenner;
      nenner *= a.nenner;
      return *this;
   }

   Fraction& operator-=(const Fraction& a)
   {
      *this += (-a);
      return *this;
   }

   Fraction& operator++()
   {
      zaehler += nenner;
      return *this;
   }

   Fraction& operator--()
   {
      zaehler -= nenner;
      return *this;
   }
 
  friend Fraction operator+(const Fraction&, const Fraction&);
  friend Fraction operator-(const Fraction&, const Fraction&);
  friend Fraction operator*(const Fraction&, const Fraction&);
  friend Fraction operator/(const Fraction&, const Fraction&)
                               throw(Fraction::DivisionByZero);
  friend ostream& operator<< (ostream& os, const Fraction& a);
  friend istream& operator>> (istream& is, Fraction& a)
                               throw(Fraction::DivisionByZero);
};
#endif 

