// ------------------------------------------------------
// matrix.h:  Darstellung von dynamischen Matrizen
// ------------------------------------------------------

#ifndef _MATRIX_H_
#define _MATRIX_H_

#include <stdexcept>
#include <iostream>
using namespace std;

class Zeile
{
    double *z;
    int size;
  public:
    Zeile( int s) { size = s; z = new double[s]; }
    ~Zeile(){ delete[]z; }
      
    double& operator[](int i) 
    {
       if(i < 0 || i >= size)
           throw out_of_range("Spaltenindex: Out of Range\n");
       return z[i]; 
    }

    const double& operator[](int i)  const
    {
       if(i < 0 || i >= size)
           throw out_of_range("Spaltenindex: Out of Range\n");
       return z[i]; 
    }
};

class Matrix
{
  private:
    Zeile **mat;          // Zeiger auf "Zeilen"-Vektor
    int lines, cols;      // Zeilen- und Spaltenzahl

  public:
    Matrix(int z , int s)
    { 
     lines = z; cols = s;

     mat = new Zeile*[lines];
     
     for(int i=0; i < lines; i++)
         mat[i] = new Zeile(cols);
    }

    Matrix:: Matrix( int z, int s, double wert);

    Matrix( const Matrix& );

    ~Matrix()
    { 
       for(int i=0; i < lines; i++)
           delete mat[i];
       delete[] mat;
    }

    int  getLines() const { return lines; }
    int  getCols()  const { return cols; }

    Zeile& operator[](int i) 
    { 
      if(i < 0 || i > lines)
         throw out_of_range("Zeilenindex: Out of Range\n");

      return *mat[i]; 
    }

    const Zeile& operator[](int i) const
    { 
      if(i < 0 || i > lines)
         throw out_of_range("Zeilenindex: Out of Range\n");

      return *mat[i];
    }
                                 // Zuweisungen:
    Matrix& operator=( const Matrix& );
    Matrix& operator+=( const Matrix& );
};

#endif
