// ------------------------------------------------------
// matrix_t.cpp : Zum Testen dynamischer Matrizen
// ------------------------------------------------------

#include "matrix.h"

void display( Matrix& m);

int main()
{
    Matrix m(4,5);

    try
    {
      int i,j;
      for( i=0; i < m.getLines(); i++)
        for( j=0; j < m.getCols(); j++)
          m[i][j] = (double)i + j/ 100.0;

      cout << "Matrix angelegt" << endl; 
      display(m);

      Matrix  cop(m);
      cout << "Kopie angelegt" << endl;  

      display(cop);
            
      cop += m;
      cout << "Summe gebildet:" << endl; 

      display(cop);

      Matrix m1(4, 5, 7.7);
      cout << "Matrix mit Wert initialisiert:" << endl; 
      display(m1);

      m = m1;
      cout << "Matrix zugewiesen:" << endl;
      display(m);
    }
    catch(out_of_range& err)
    {
       cerr << err.what() << endl;
       exit(1);
    }

    return 0;
}


void display( Matrix& m)
{
    for(int i=0; i < m.getLines(); i++)
    {
      for(int j=0; j < m.getCols(); j++)
         cout << m[i][j] << "  ";
        
      cout << endl;
    }
    cin.get();
}
