// varTemplate.cpp: Variadische Template-Funktion
//-----------------------------------------------
#include <iostream>
#include <string>
using namespace std;

/* Visual C++ 2012 unterstzt noch keine variadische Templates

template<class T>                    // Basisfall 
T add(const T& a)
{
    return a;
}

template<class T, class ... Args>    // Rekursion
T add(const T& first, const Args& ...rest)
{
    return first + add(rest...);
} 
*/

// Alternative mit Default-Argumenten fr Aufrufe mit
// bis zu 4 Argumenten gleichen Typs.

template<class T>
T add(const T& a1, const T& a2 = T(), const T& a3 = T(), const T& a4 = T())
{
    return a1 + a2 + a3 + a4;
}

int main()
{
   cout << add(1, 2) << endl;
   cout << add(3.5, 7.1, 8.2) << endl;
   cout << add(-10, -21, 30, 45) << endl;

   string s1 ="Sonnen", s2 ="blumen", s3 ="kerne"; 
   cout << add(s1, s2, s3) << endl;

   return 0;
}
