// thread_sort.cpp
// Sortiert zwei Vektorhlften und mischt sie.
//----------------------------------------------------
#include <thread>
#include <cstdlib>              // Fr rand(), srand()
#include <iostream>
using namespace std;

#define MAX 100

void initialize(int* pv, int len) 
{                                    
  for(int i= 0; i < len; i++)
      pv[i] = rand();
}

void selectionSort(int* pv, int n)  // Selection-Sort-
{                                   // Algorithmus.
  int i, j, merke, temp;
  for(i = 0; i < n-1; i++)
  {                                 // Position vorlufig
    merke = i;                      // kleinstes Element.
    for(j = i+1; j < n; j++)        // Kleineres Element
     if(pv[j] < pv[merke])          // suchen.
       merke = j;  
                                    // Elemente tauschen:
    temp = pv[i]; pv[i] = pv[merke]; pv[merke] = temp;
  }
}

void merge(int* pv, int n );   // Mischt die beiden
                               // sortierten Vektorhlften.

int main()
{
   int v[MAX];
   initialize(v, MAX);              // Initialisierung.
   int len1 = MAX/2 ;             
   int len2 = MAX - len1;  	
                // Vektorhlften mit Threads sortieren:
   thread t1(selectionSort, v, len1);       
   thread t2(selectionSort, v + len1, len2);   
   
   t1.join(); t2.join();  // Warten bis Sortierung 
                          // abgeschlossen. 
   merge(v, MAX);         // Sortierte Hlften mischen:
                          // wie in Kap. 21, 2. Aufgabe.
   for( int i = 0; i < MAX; ++i)
   {  
      cout.width(7);  cout << v[i];
      if( (i+1)%8 == 0)
          cout << endl;
   }
   cout << endl;
   return 0;
}

#include <cstring>            // Fr memcpy()
int *merge( int v1[], int len1, int v2[], int len2);

void merge(int* pv, int n )   // Mischt die beiden sortierten Vektorhlften
{                             // im Vektor pv der Lnge n und schreibt
    if( n > 1)                // das Ergebnis in pv zurck.
    {
       int len1 = n/2;
       int *vnew = merge( pv, len1, pv+len1, n-len1);
       std::memcpy( pv, vnew, n*sizeof(int));
       delete vnew;
    }
}

// Sortierte Vektoren v1 und v2 mischen. 
// Zeiger auf dynamischen Vektor mit dem Ergebnis zurckgeben.
int *merge( int v1[], int len1, int v2[], int len2)
{
   int i = 0, i1 = 0, i2 = 0;

   int *v = new int[len1+len2];

   for( i=0; i1 < len1 && i2 < len2; ++i)
   {
       if( v1[i1] <= v2[i2])
           v[i] = v1[i1++];
       else
           v[i] = v2[i2++];
   }
   
   if( i1 < len1)            // Rest von v1 oder v2 kopieren.
     while( i1 < len1)
       v[i++] = v1[i1++];
   else
     while( i2 < len2)
       v[i++] = v2[i2++];

   return v;
}
