// --------------------------------------------------------
// Fraction.cpp
// Definition der Methoden und friend-Funktionen.
// --------------------------------------------------------

#include <iostream>
#include <cstdlib>
#include "Fraction.h"
using namespace std;

// Konstruktor:
Fraction::Fraction(long z, long n)
{
   if(n == 0)
   {
     cerr << "\nFehler: Division durch Null!\n";
     exit(1);
   }
   if( n < 0 )
      z = -z, n = -n;
   zaehler = z;
   nenner  = n;
}

Fraction operator+(const Fraction& a, const Fraction& b )
{
   Fraction temp;

   temp.nenner = a.nenner * b.nenner;
   temp.zaehler = a.zaehler*b.nenner + b.zaehler * a.nenner;

   return temp;
}

Fraction operator-(const Fraction& a, const Fraction& b )
{
   Fraction temp = a;

   temp += (-b);

   return temp;
}

Fraction operator*(const Fraction& a, const Fraction& b )
{
   Fraction temp;

   temp.zaehler = a.zaehler * b.zaehler;
   temp.nenner  = a.nenner  * b.nenner;

   return temp;
}

Fraction operator/(const Fraction& a, const Fraction& b )
{
   if( b.zaehler == 0)
   {
     cerr << "\nFehler: Division durch Null!\n";
     exit(1);
   }

   Fraction temp;             // a mit dem Kehrwert von b multiplizieren
   temp.zaehler = a.zaehler * b.nenner;
   temp.nenner  = a.nenner  * b.zaehler;

   if( temp.nenner < 0 )
     temp.zaehler = -temp.zaehler,
     temp.nenner  = -temp.nenner;

   return temp;
}

ostream& operator<<(ostream& os, const Fraction& a)
{
  os << a.zaehler << "/" << a.nenner;
  return os;
}

istream& operator>>(istream& is, Fraction& a)
{
  cout << "Bruch eingeben:\n"
          "  Zaehler:      ";   is >> a.zaehler;
  cout << "  Nenner != 0:  ";   is >> a.nenner;

  if( !is) return is;

  if( a.nenner == 0)
  {
     cout << "\nFehler: Der Nenner ist 0\n"
             "  Neuer Nenner != 0: ";   is >> a.nenner;

     if( a.nenner == 0)
     {
       cerr << "\nFehler: Division durch Null!\n";
       exit(1);
     }
  }
  if( a.nenner < 0 )
     a.zaehler = -a.zaehler,
     a.nenner  = -a.nenner;

  return is;
}

