// ---------------------------------------------------
// merge.cpp 
// Implementierung des Merge-Algorithmus.
// ---------------------------------------------------

#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <ctime>
using namespace std;

// Prototypen:
void selectionSort( int arr[], int len);
int *merge( int v1[], int len1, int v2[], int len2);

int main()
{
    cout << "\n  * * *  Merge-Algorithmus  * * *\n"
         << endl;

    int i, len1 = 10, len2 = 20;
    int *a1 = new int[len1],
        *a2 = new int[len2];

    srand( (unsigned)time(NULL));  // Zufallsgenerator mit
                                   // akt. Zeit initialisieren.

    for( i=0; i < len1; ++i)       // Vektoren initialisieren. 
       a1[i] = rand();

    for( i=0; i < len2; ++i) 
       a2[i] = rand();

    selectionSort( a1, len1);      // Vektoren sortieren.
    selectionSort( a2, len2);      // Vektoren sortieren.

   // Vektoren ausgeben
   cout << "Die sortierten Vektoren:" << endl;

   cout << "1. Vektor: " << endl;
   for( i = 0; i < len1; ++i)
      cout << setw(8) << a1[i];
   cout << endl;

   cout << "2. Vektor: " << endl;
   for( i = 0; i < len2; ++i)
      cout << setw(8) << a2[i];
   cout << endl;

   int *a3, len3;
   a3   = merge( a1, len1, a2, len2);
   len3 = len1 + len2;

   cout << "Der neue gemischte Vektor: " << endl;
   for( i = 0; i < len3; ++i)
      cout << setw(8) << a3[i];
   cout << endl;

   delete[] a1;   delete[] a2;   delete[] a3;
   return 0;
}

inline void swap( int& a, int& b)
{
   int temp = a;  a = b;  b = temp;
}

void selectionSort( int *arr, int len)
{
   register int *p, *minp;     // Zeiger auf Vektorelemente,
   int *last = arr + len-1;    // Zeiger auf das letzte Elem.

   for( ; arr < last;  ++arr)
   {
      minp = arr;                     // Ab Position arr das
      for( p = arr+1; p <= last; ++p) // Minimum suchen.
         if( *minp > *p)
             minp = p;

      swap( *arr, *minp);             // Tauschen.
   }
}

// Zwei sortierte Vektoren so mischen, da die Summe 
// beider Vektoren wieder sortiert ist.
int *merge( int v1[], int len1, int v2[], int len2)
{
   int i = 0, i1 = 0, i2 = 0;

   int *v = new int[len1+len2];

   for( i=0; i1 < len1 && i2 < len2; ++i)
   {
       if( v1[i1] <= v2[i2])
           v[i] = v1[i1++];
       else
           v[i] = v2[i2++];
   }
   
   if( i1 < len1)            // Rest von v1 oder v2 kopieren.
     while( i1 < len1)
       v[i++] = v1[i1++];
   else
     while( i2 < len2)
       v[i++] = v2[i2++];

   return v;
}
