// sharedPtr3.cpp
// shared_ptr mit selbst definiertem Deleter 
// -----------------------------------------------------
#include <iostream>
#include <memory>
using namespace std;

template<class T> struct arrayDeleter 
{ 
    void operator()(T *p)  {
       cout << "--- arrayDeleter aufgerufen! ---" << endl;
       delete [] p; 
    } 
}; 

struct X
{
    static long idCount;
    long id;
    X() : id(++idCount) { }
    ~X() { cout << "X-Destruktor " << id << endl; }
};
long X::idCount = 100;

int main() 
{ 
   int len = 16;
   shared_ptr<int> spArr(new int[len], arrayDeleter<int>());

   *spArr = 1;
   int* arr = spArr.get();              // Startadresse des Vektors.
   for( int i = 1; i < len; ++i)
      arr[i] = 2*arr[i-1];
   for( int i = 0; i < len; ++i)        // 1  2  4  8  16 .... 
      cout << "  " << arr[i];
   cout << endl;
   spArr.reset();   // Aufruf von arrayDeleter: delete[] arr;

   {
      shared_ptr<X> spXarr(new X[3], arrayDeleter<X>());
      cout << "Deleter von spXarr: " 
           << (void*)get_deleter<arrayDeleter<X> >(spXarr) << endl;
      cout << "Erstes Element *spXarr == " << spXarr->id << endl;
   }               // spXarr-Destruktor => Aufruf von arrayDeleter.
                   // Ausgabe der X-Destruktoren.
   return 0; 
} 

/* Beispielausgabe:

  1  2  4  8  16  32  64  128  256  512  1024  2048  4096  8192  16384  32768
--- arrayDeleter aufgerufen! ---
Deleter von spXarr: 00345318
Erstes Element *spXarr == 101
--- arrayDeleter aufgerufen! ---
X-Destruktor 103
X-Destruktor 102
X-Destruktor 101
*/
