// uniquePtr3.cpp
// Ein unique_ptr auf ein dynamisches Array.
// --------------------------------------------------
#include <iostream>
#include <string>
#include <memory>
using namespace std;

class Person
{  
    string name;
  public:
	Person( const string n = "NN") : name(n) {}
    ~Person() { cout << "Destruktor fuer " << name << endl; }
	void setName(const string& n) { name = n; }
	const string& getName() const { return name; }
};

typedef unique_ptr<Person[]> PersonArr_t;

void print( const PersonArr_t& parr, int l)
{
	for( int i=0; i < l; ++i)
      cout << '\t' << parr[i].getName();
	cout << endl;
}

int main()
{
   int len = 4;
   PersonArr_t PersonArr(new Person[len]);    // Smart Pointer auf Vektor. 

   PersonArr[0].setName("Jim"); 
   PersonArr[1].setName("Max");
   PersonArr[3].setName("Eva");

   print( PersonArr, len);
   //   cout << PersonArr->getName();  // Fehler:
                                       // Operatoren * und -> nicht definiert.
   PersonArr.reset();         // delete [] PersonArr.get(); 

   return 0;
}

/* Ausgabe:

        Jim     Max     NN      Eva
Destruktor fuer Eva
Destruktor fuer NN
Destruktor fuer Max
Destruktor fuer Jim

*/
