// funcObj.cpp: Ein Beispiel mit Funktionsobjekten.
// ---------------------------------------------------------------
#include "funcObj.h"       // Definition eigener Klassen 
#include <iostream>
#include <algorithm>       // Definition der Algorithmen-Templates
#include <functional>      // Vordefinierte Funktionsobjekte
using namespace std;

int main()
{
    double werte[] = { 3.91, 5.29, 7.88, 10.31, 8.47, 6.05, 4.77 };
    int len = sizeof(werte)/sizeof(double);    // Anzahl Elemente im Vektor

    // Alle Elemente anzeigen:
    cout << "Die Elemente des Vektors:" << endl;
    for_each( werte, werte + len, PrintDbl());   // 5 Spalten pro Zeile,
                                                 // jeweils mit Feldbreite 10
    cout << endl;

    // Alle Elemente aufsummieren und Summe, Durchschnitt anzeigen.
    Summe s = for_each( werte, werte + len, Summe()); 
    cout << "\nSumme:        " << s.getSumme() << endl
         <<   "Durchschnitt: " << s.getSumme() / s.getAnzahl() << endl;

    // Vektor absteigend sortieren
    sort( werte, werte + len, greater<double>() );
    // und ausgeben:
    cout << "\nDer absteigend sortierte Vektor: " << endl;
    for_each( werte, werte + len, PrintDbl(8,6)); // 8 Spalten pro Zeile,
    cout << endl;                                 // jeweil mit Feldbreite 6

    return 0;
}

/* Ausgabe:

Die Elemente des Vektors:
      3.91      5.29      7.88     10.31      8.47
      6.05      4.77

Summe:        47
Durchschnitt: 6.7

Der absteigend sortierte Vektor:
 10.31  8.47  7.88  6.05  5.29  4.77  3.91

*/
