// heap.cpp: Beispiele zu den Heap-Algorithmen.
// ---------------------------------------------------------------
#include <iostream>
#include <vector>           // Definition des vector-Templates
#include <algorithm>        // Definition der Algorithmen-Templates
#include <iterator>
#include <cstdlib>
using namespace std;

void print( const vector<int>& v)
{
   copy(v.begin(), v.end(), ostream_iterator<int>(cout,"  "));
   cout << endl;
}

int main()
{
    vector<int> arr;                     // Leerer Vektor
    int i;
    for( i = 0; i < 10; ++i)
        arr.push_back( rand()%10 );
    cout << "Vektor vor make_heap():   ";  print( arr);    

    make_heap( arr.begin(), arr.end());
    cout << "Vektor nach make_heap():  ";  print( arr); 

    // Grstes Element entnehmen:
    pop_heap( arr.begin(), arr.end());
    cout << "Vektor nach pop_heap():   ";  print( arr); 
    cout << "\"Entnommen\" wurde:  " << arr[9] << endl;
    
    // und das zweitgrsste Element entnehmen:
    pop_heap( arr.begin(), arr.end()-1);
    cout << "Vektor nach pop_heap():   ";  print( arr); 
    cout << "\"Entnommen\" wurde:  " << arr[8] << endl;

    cout << arr[8] << " wieder einfuegen:" << endl; 
    push_heap( arr.begin(), arr.end()-1);
    cout << "Vektor nach push_heap():  ";  print( arr); 

    // Den restlichen Heap sortieren:
    sort_heap( arr.begin(), arr.end()-1);
    cout << "Vektor nach sort_heap():  ";  print( arr); 

    vector<int>::iterator pos =
        lower_bound( arr.begin(), arr.end(), 2);
    i = (int)(pos - arr.begin());                  // Index zum Iterator pos
    if( pos != arr.end() && *pos == 2)
       cout << "Die erste 2 ist das " << i+1 << ".te Element" << endl;
    else 
       cout << "2 ist nicht im Vektor vorhanden." << endl;

    return 0;
}

/* Beispiel-Ausgabe:

Vektor vor make_heap():   1  7  4  0  9  4  8  8  2  4
Vektor nach make_heap():  9  8  8  2  7  4  4  0  1  4
Vektor nach pop_heap():   8  8  4  2  7  4  4  0  1  9
"Entnommen" wurde:  9
Vektor nach pop_heap():   8  7  4  2  1  4  4  0  8  9
"Entnommen" wurde:  8
8 wieder einfuegen:
Vektor nach push_heap():  8  8  4  7  1  4  4  0  2  9
Vektor nach sort_heap():  0  1  2  4  4  4  7  8  8  9
Die erste 2 ist das 3.te Element
*/
