// ------------------------------------------------------
// max.cpp 
// Definition und Aufruf der berladenen Funktionen Max().
// ------------------------------------------------------

// Solange nur eine Funktion Max() definiert ist, kann
// sie mit allen Argumenten aufgerufen werden, deren Typ
// in double konvertierbar ist, also auch mit Werten vom
// Typ char, int oder long.
// Nach einer berladung ist keine eindeutige Konvertierung
// mehr mglich.

#include <iostream>
#include <string>
using namespace std;

inline double Max(double x, double y)
{
   cout << "double-Version von Max()" << endl; //Zum Testen
   return (x < y ? y : x);
}

inline char Max(char x, char y)
{
   cout << "char-Version von Max()" << endl; //Zum Testen
   return (x < y ? y : x);
}

string header("Mit der berladenen Funktion Max() arbeiten.\n"),
       linie(50,'-');

int main()    // verschiedene Aufrufe der Funktion Max() 
{
   double x1 = 0.0, x2 = 0.0;
    
   linie += '\n';
   cout << linie << header << linie << endl;
   
   cout << "Geben Sie zwei Gleitpunkzahlen ein:"
        << endl;
   if( cin >> x1  &&  cin >> x2)
   {
       cout << "Die grere Zahl ist " << Max(x1,x2)
            << endl;
   }
   else
       cout << "Fehlerhafte Eingabe!" << endl;

   cin.sync(); cin.clear();   // falls eine falsche Eingabe
                              // gemacht wurde.

   cout << linie
        << "Und jetzt nochmal mit Zeichen!"
        << endl;
   
   cout << "Geben Sie zwei Zeichen ein:"
        << endl;

   char c1, c2;
   if( cin >> c1  &&  cin >> c2)
   {
       cout << "Das grer Zeichen ist " << Max(c1,c2)
            << endl;
   }
   else
       cout << "Fehlerhafte Eingabe!" << endl;


   cout << "Test mit int-Argumenten." << endl;
   int  a = 30, b = 50;
//   cout << Max(a,b) << endl;     // Fehler! Welche 
                                 // Funktion Max()?
   return 0;
}
