// ----------------------------------------------------
// guadGl.cpp
// Definition und Aufruf der Funktion quadGleichung(),
// die die Lsungen einer quadratischer Gleichungen 
//            a*x*x + b*x + c = 0
// berechnet. Die Gleichung und die Lsungen dazu werden
// mit der Funktion printQuadGleichung() angezeigt.
// ----------------------------------------------------

#include <iostream>
#include <iomanip>
#include <string>
#include <cmath>              // fr die Wurzel sqrt()
using namespace std;

string header =
       " *** Lsungen von quadratischen Gleichungen ***\n",
       line( 50, '-');

// -----  Prototypen -----
// Loesunen berechnen:
bool quadGleichung( double a, double b, double c,
                    double* x1Ptr, double* x2Ptr);

// Gleichung und Loesung ausgeben:
void printQuadGleichung( double a, double b, double c);

int main()   
{
   cout << header << endl;

   printQuadGleichung( 2.0, -2.0, -1.5);

   printQuadGleichung( 1.0, -6.0, 9.0);

   printQuadGleichung( 2.0,  0.0, 2.0);

   return 0;
}

// Gleichung und Loesung ausgeben:
void printQuadGleichung( double a, double b, double c)
{
   double x1 = 0.0, x2 = 0.0;     // Fr die Lsungen

   cout << line << '\n'
        << "\nDie quadratische Gleichung:\n\t "
        << a << "*x*x + " << b << "*x + " <<  c << " = 0"
        << endl;
   
   if( quadGleichung( a, b, c, &x1, &x2) )
   {
     cout << "besitzt die reellen Lsungen:"
          << "\n\t x1 = " << x1
          << "\n\t x2 = " << x2 << endl;
   }
   else
     cout << "besitzt keine reelle Lsung!" << endl;
   
   cout << "\nWeiter mit Return. \n\n";
   cin.get();
}

bool quadGleichung( double a, double b, double c,
                    double* x1Ptr, double* x2Ptr)
// Lst die quadratische Gleichung:
//            a*x*x + b*x + c = 0
// Schreibt die Lsungen der Gleichung in die Variablen, auf
// die x1Ptr und x2Ptr zeigen.
// Return-Wert: true, falls es eine Lsung gibt,
//              false sonst.
{
    bool return_flag = false;

    double hilf = b*b - 4*a*c;

    if( hilf >= 0)          // Es gibt reelle Loesungen
    {
      hilf = sqrt( hilf);

      *x1Ptr = (-b + hilf) / (2*a);
      *x2Ptr = (-b - hilf) / (2*a);

      return_flag = true;
    }
    return return_flag;
}
