 // demo.cpp 
 // Zeigt Konstruktor- und Destruktoraufrufe an.
 // ---------------------------------------------------

 #include <iostream>
 #include <string>
 using namespace std;

 int zaehler = 0;         // Fr die Anzahl der Objekte.
 
 class Demo
 {
    private:   string name;

    public:    Demo( const string& );    // Konstruktor
              ~Demo();                   // Destruktor
 };
 
 Demo::Demo( const string& str)
 {
    ++zaehler;
    name = str;
 
    cout << "Ich bin der Konstruktor fuer "<< name << ".\n"
         << "Das ist das " << zaehler << ". Objekt!"
         << endl;
 }
 
 Demo:: ~Demo()          // Definition des Destruktors
 {
    cout << "Ich bin der Destruktor von " << name << ".\n"
         << "Das " << zaehler << ". Objekt " 
         << "wird zerstoert" << endl;
    --zaehler;
 }
 
 // -- Objekte der Klasse Demo erzeugen und zerstren --
 
 Demo globalObject("Das globale Objekt");
 
 int main()
 {
    cout << "Die erste Anweisung in main()." << endl;
 
    Demo firstLocalObject("Das erste lokale Objekt");
    {
      Demo secLocalObject("Das zweite lokale Objekt");
      
      static Demo staticObjekt("Das statische Objekt");
    
      cout << "\nDie letzte Anweisung im inneren Block"
           << endl;
    }
    cout << "Die letzte Anweisung in main()." << endl;
    
    return 0; 
 }
