// standard.cpp 
// Zeigt die Verwendung der Standard-Methoden.
// ---------------------------------------------------

#include <iostream>
#include <iomanip>
#include <string>
using namespace std;

class CD
{
   private:
     string interpret, title;
     long   seconds;             // Spieldauer 

   public:
     // Konstruktoren 
     CD( const string& i="", const string& t="", long s = 0L)
     { 
        interpret = i;    title = t;    seconds = s;
     }
     const string& getInterpret() const{ return interpret; }
     const string& getTitle() const    { return title; }
     long  getSeconds() const          { return seconds; }
};

// Objekte der Klasse CD erzeugen und tabellarisch anzeigen.

void printLine( const CD& cd) ;   // Eine Zeile der Tabelle

int main()
{
   CD cd1( "Mister X", "Let's dance", 30*60 + 41),
      cd2( "New Gittars", "Flamenco Collection", 2772 ),
      cd3 = cd1,                   // Kopier-Konstruktor!
      cd4;                         // Default-Konstruktor.

      cd4 = cd2;                   // Zuweisung!

   string line( 70,'-');   line += '\n';
   cout << line 
        << left << setw(20) << "Interpret" << setw(30) << "Title" 
        << "Spieldauer (Min:Sec)\n"
        << line << endl;
   
   printLine(cd3);                 // Kopier-Konstruktor!
   printLine(cd4);
       
   return 0; 
}

void printLine( const CD& cd) 
{
   cout << left  << setw(20) << cd.getInterpret().c_str()
                 << setw(30) << cd.getTitle().c_str()
        << right << setw(5)  << cd.getSeconds() / 60
        << ':'   << setw(2)  << cd.getSeconds() % 60 << endl;
}
