// ------------------------------------------------------
// KontoRW.cpp 
// Einen Vektor mit Objekten der Klasse Konto in eine Datei
// schreiben und in einen anderen Vektor einlesen.
// ------------------------------------------------------

#include "konto.h"      // Definition der Klasse Konto
#include <iostream>
#include <fstream>
using namespace std;

Konto kontoTab1[3] =
{
  Konto("Lustig, Peter", 1234567, -1200.99),
  Konto("Mueller, Sarah", 123000, 2500.0),
  Konto("Schmidt, Jean\n"              // String kann mehrere
        "Handy: 01771234567", 543001)  // Zeilen haben.
};

Konto kontoTab2[3];     // Aufrufe des Default-Konstrukors

int anz = 3;

char datei[] = "Konten.dat";

int main()
{
   int i = 0;

   // --- Konten in eine Datei schreiben --- 

   ofstream outFile( datei, ios::out | ios::binary );
   if( ! outFile)
   {
     cerr << "Fehler beim ffnen der Datei " << datei << endl;
     return 1;
   }
   for( i = 0; i < anz; ++i)
     if( !kontoTab1[i].write(outFile) )
     {
       cerr << "Fehler beim Schreiben der Datei " << datei << endl;
       return 2;
     }
   outFile.close();

   // --- Konten aus der Datei wieder einlesen --- 
   
   ifstream inFile( datei, ios::out | ios::binary );
   if( ! inFile)
   {
     cerr << "Fehler beim ffnen der Datei " << datei << endl;
     return 3;
   }
   for( i = 0; i < anz; ++i)
     if( !kontoTab2[i].read(inFile) )
     {
       cerr << "Fehler beim Lesen der Datei " << datei << endl;
       return 2;
     }
   inFile.close();
   
   // --- Gelesene Konten anzeigen  ---

   cout << "Die Datei " << datei << " enthlt die Konten:" << endl;

   for( i = 0; i < anz; ++i)
      kontoTab2[i].display();

   cout << endl;

   return 0;
}
