// -------------------------------------------------
// mitarb_t.cpp: Zum Testen der Klassen
//               Mitarbeiter, Angestellter, Arbeiter
// -------------------------------------------------

#include "mitarb.h"

// Demo-Funktion:
void copy( Mitarbeiter& a, const Mitarbeiter& b ); 

int main()
{
    Angestellter pfoertner("Heiter, Paul", 2350.0);
    pfoertner.display();
    cout << "\nEinkommen des Angestellten: "
         << pfoertner.einkommen() << endl;

    Angestellter vertretung;
    copy(vertretung, pfoertner); 
    vertretung.display();

    vertretung = pfoertner;     // Nicht virtuelle Zuweisung
    cout << "\nNach der Zweisung: ";
    vertretung.display();
    cin.get();

    Arbeiter maurer("Milo, Luis", 53.50, 40);
    maurer.display();
    cout << "\nEinkommen des Arbeiters:   "
         << maurer.einkommen() << endl;

    Arbeiter azubi;
    copy(azubi, maurer);
    cout << "\nEinkommen des Azubis nach dem Kopieren: " 
         <<  azubi.einkommen()<< endl;

    azubi.setLohn(12.0);
    azubi.setStd(20);
    maurer = azubi;         // Nicht vituelle Zuweisung

    cout << "\nEinkommen des Maurers nach der Zuweisung: "  
         << maurer.einkommen();
    maurer.display();

    cout << "\nUnd jetzt mit dynamisch reserviertem Speicher: ";
    Mitarbeiter* mitPtr1;
	mitPtr1 = new Arbeiter("Nell, Rudi",45., 40);
    mitPtr1->display();
	cout << "\nEinkommen:   " << mitPtr1->einkommen() << endl;

    Mitarbeiter* mitPtr[2];
    mitPtr[0] = new Arbeiter("Nell, Rudi",45., 40);
    mitPtr[1] = new Angestellter("Sommer, Eva", 3850.0);

    for( int i = 0; i < 2; ++i)
    {
      mitPtr[i]->display();
      cout << "\nEinkommen von " << mitPtr[i]->getName() << " :  "
           << mitPtr[i]->einkommen() << endl;
    }
    return 0;
}

void copy(Mitarbeiter& a,const Mitarbeiter& b)
{
    a = b;        // Aufruf der virtuellen Zuweisung
}
