// ---------------------------------------------------
// hash_t.cpp:  Zum Testen von Hash-Dateien
// ---------------------------------------------------

#include <iostream>
#include <string>
#include "hash_dat.h"
using namespace std;

int main()
{
  try
  {
    HashFile hash("Kunden.dat", 7);   // Adressraum der Lnge 7

    cout << "\nEinfuegen: " << endl;
    HashEntry kde( 3L, "Vivi");
    hash.insert( kde ); 

    kde.setNr(10L); kde.setName("Peter");
    hash.insert( kde );

    kde.setNr(17L); kde.setName("Ulla");
    hash.insert( kde );

    kde.setNr(21L); kde.setName("Peter");
    hash.insert( kde );

    kde.setNr(15L); kde.setName("Jeany");
    hash.insert( kde );
    cout << "\nEinfuegen fertig!\n"
         << "Inhalt der Hash-Datei:\n"
         << "(Weiter mit <Return>" << endl;
    
    hash.display();

    unsigned long key;
    cout << "Key? ";  cin >> key;

    HashEntry temp = hash.retrieve(key);
    if(temp.getNr() != 0L)
       temp.display();
    else
       cout << "Schluessel " << key << " nicht gefunden" << endl; 

  }
  catch(open_error& err)
  {
     cerr << "Fehler beim Oeffnen der Datei: " << err.getName() << endl;
     exit(1);
  }
  catch(write_error& err)
  {
     cerr << "Fehler beim Schreibzugriff in Datei: " << err.getName() << endl;
     exit(1);
  }
  catch(read_error& err)
  {
     cerr << "Fehler beim Lesezugriff auf Datei: " << err.getName() << endl;
     exit(1);
  }

  return 0;
}