// varTemplate.cpp: Variadische Template-Funktion
//-----------------------------------------------
#include <iostream>
#include <string>
using namespace std;

template<class T>                    // Basisfall 
T add(const T& a)
{
    return a;
}

template<class T, class ... Args>    // Rekursion
T add(const T& first, const Args& ...rest)
{
    return first + add(rest...);
} 

int main()
{
   cout << add(1, 2) << endl;
   cout << add(3.5, 7.1, 8.2) << endl;
   cout << add(-10, -21, 30, 45) << endl;

   string s1 ="Sonnen", s2 ="blumen", s3 ="kerne"; 
   cout << add(s1, s2, s3) << endl;

   return 0;
}
